<?php
/**
 * @copyright   Copyright (C) Chatbro. All rights reserved.
 * @license     GNU General Public License version 2 or later.
 */

namespace Chatbro\Component\Chatbrocomponent\Administrator\Controller;

defined('_JEXEC') or die();

use Joomla\CMS\MVC\Controller\BaseController;
use Joomla\CMS\Application\CMSApplication;
use Joomla\CMS\Form\FormFactoryInterface;
use Joomla\CMS\MVC\Factory\MVCFactoryInterface;
use Joomla\Input\Input;
use ChatbroChatbrochats as Chatbro;

class AjaxController extends BaseController
{
	private $chatbro;

	public function __construct(
		$config = [],
		MVCFactoryInterface $factory = null,
		?CMSApplication $app = null,
		?Input $input = null,
		FormFactoryInterface $formFactory = null
	) {
		parent::__construct($config, $factory, $app, $input, $formFactory);

		$this->chatbro = new Chatbro();
		$this->chatbro->init();
		
		$document = $this->app->getDocument();
		$document->setMimeEncoding('application/json');
		
		$this->registerTask('gcu', 'get_chats_url');
		$this->registerTask('ss', 'save_settings');
		$this->registerTask('cc', 'create_chat');
		$this->registerTask('uc', 'update_chat');
		$this->registerTask('dc', 'delete_chat');
	}

	public function get_chats_url($cachable = false, $urlparams = [])
	{
		$this->checkToken('request');
		echo json_encode($this->chatbro->getChats(), JSON_PRETTY_PRINT);
	}

	public function save_settings($cachable = false, $urlparams = [])
	{
		$this->checkToken('request');
		echo json_encode($this->chatbro->saveSettings(), JSON_PRETTY_PRINT);
	}

	public function create_chat($cachable = false, $urlparams = [])
	{
		$this->checkToken('request');
		echo json_encode($this->chatbro->createChat(), JSON_PRETTY_PRINT);
	}

	public function update_chat($cachable = false, $urlparams = [])
	{
		$this->checkToken('request');
		echo json_encode($this->chatbro->updateChat(), JSON_PRETTY_PRINT);
	}

	public function delete_chat($cachable = false, $urlparams = [])
	{
		$this->checkToken('request');
		echo json_encode($this->chatbro->deleteChat(), JSON_PRETTY_PRINT);
	}
}
