<?php
/**
 * @copyright   Copyright (C) Chatbro. All rights reserved.
 * @license     GNU General Public License version 2 or later.
 */

namespace Chatbro\Component\Chatbrocomponent\Administrator\Controller;

defined('_JEXEC') or die();

use Joomla\CMS\MVC\Controller\BaseController;
use Joomla\CMS\Factory;

use Joomla\CMS\Application\CMSApplication;
use Joomla\CMS\Form\FormFactoryInterface;
use Joomla\CMS\MVC\Factory\MVCFactoryInterface;
use Joomla\Input\Input;


class DisplayController extends BaseController
{
	public function __construct(
		$config = [],
		MVCFactoryInterface $factory = null,
		?CMSApplication $app = null,
		?Input $input = null,
		FormFactoryInterface $formFactory = null
	) {
		parent::__construct($config, $factory, $app, $input, $formFactory);
	}

	public function display($cachable = false, $urlparams = [])
	{
		$document = Factory::getDocument();
		$viewName = $this->input->getCmd('view', 'chatbro');
		$viewFormat = $document->getType();

		$view = $this->getView($viewName, $viewFormat);

		$model = $this->getModel('Chatbro', 'Administrator');

		$view->setModel($model, true);

		$view->document = $document;
		$view->display();
	}
}
