<?php
/**
 * @copyright   Copyright (C) Chatbro. All rights reserved.
 * @license     GNU General Public License version 2 or later.
 */

defined('_JEXEC') or die();
defined('_JEXEC') or die();
defined('CHATBROENGINE') || die();


use ChatbroChatbroappUtilsCbro_utils as CbroUtils;
use ChatbroChatbroappSettingsCbro_settings as CbroSettings;
use ChatbroChatbroappChatsCbro_chats as CbroChats;
use ChatbroChatbroappChatsCbro_display_chat as CbroDisplayChat;
use ChatbroChatbroappUsersCbro_user as CbroUser;
use ChatbroChatbroappExceptionsCbro_chat_not_found as CbroChatNotFound;

class ChatbroChatbroappShortCodesCbro_short_code
{
	private static $instance = null;

	private function __construct()
	{
	}

	public static function get_instance()
	{
		if (!self::$instance) {
			self::$instance = new ChatbroChatbroappShortCodesCbro_short_code();
		}
		return self::$instance;
	}

	public static function render($atts)
	{
		$a = CbroUtils::merge_attributes($atts, [
			'static' => true,
			'registered_only' => false,
			'title' => null,
			'child' => false,
			'ext_id' => null,
			'id' => null,
		]);

		if (!CbroSettings::get(CbroSettings::enabled)) {
			return '';
		}

		if (!CBroSettings::get(CBroSettings::enable_shortcodes)) {
			return '';
		}

		$chat_id = $a['id'];
		$chat = null;

		if ($chat_id) {
			try {
				$chat = CBroChats::get($chat_id);
			} catch (CBroChatNotFound $ex) {
				return;
			}
		} else {
			$chat = CBroChats::get_default_chat();
		}

		if (!isset($chat)) {
			return;
		}

		$registered_only =
			$atts && array_key_exists('registered_only', $atts)
				? strtolower($a['registered_only']) == 'true' ||
					$a['registered_only'] == '1'
				: !$chat->get_display_to_guests();

		if (
			!CbroUser::can_view($chat->get_display_to_guests()) ||
			($registered_only && !CBroUser::is_logged_in())
		) {
			return '';
		}

		$static = strtolower($a['static']) == 'true' || $a['static'] == '1';
		$child = strtolower($a['child']) == 'true' || $a['child'] == '1';

		if ($child && $a['title']) {
			$code = (new CbroDisplayChat($chat))->get_child_chat_code(
				$static,
				$a['title'],
				$a['ext_id']
			);
		} else {
			$code = $static
				? (new CbroDisplayChat($chat))->get_static_chat_code()
				: (new CbroDisplayChat($chat))->get_chat_code();
		}

		echo $code;
	}
}
